<?php

/*****************************************************************************

    Mysta - Tiny web framework.

    Copyright (C) 2012  Fabien LOISON

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

*****************************************************************************/


/**
 * Determine the current route from the URI.
 *
 * @return
 *   The current route.
 */
function get_current_route() {
	if (isset($_SERVER['PATH_INFO'])) {
		return $_SERVER['PATH_INFO'];
	}

	// /something/index.php?
	$base = $_SERVER['PHP_SELF'] . '?';
	if (strpos($_SERVER['REQUEST_URI'], $base) === 0)
	{
		return str_replace($base, '', $_SERVER['REQUEST_URI']);
	}

	// /something/?
	$base = str_replace('index.php', '', $_SERVER['PHP_SELF']) . '?';
	if (strpos($_SERVER['REQUEST_URI'], $base) === 0)
	{
		return str_replace($base, '', $_SERVER['REQUEST_URI']);
	}

	//Else...
	return $_SERVER['REQUEST_URI'];
}


/**
 * Determine the base URI.
 *
 * @return
 *   The base URI.
 */
function get_base_uri() {
	// /something/index.php?
	$base = $_SERVER['PHP_SELF'] . '?';
	if (strpos($_SERVER['REQUEST_URI'], $base) === 0)
	{
		return $base;
	}

	// /something/index.php/
	if (isset($_SERVER['PATH_INFO'])) {
		$base = str_replace($_SERVER['PATH_INFO'], '', $_SERVER['PHP_SELF']);
		if (strpos($_SERVER['REQUEST_URI'], $base) === 0)
		{
			return $base;
		}
	}

	// /something/?
	$base = str_replace('index.php', '', $_SERVER['PHP_SELF']) . '?';
	if (strpos($_SERVER['REQUEST_URI'], $base) === 0)
	{
		return $base;
	}

	//Else...
	return '';
}
